VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form FrmMain 
   Caption         =   "F-4 processor simulator"
   ClientHeight    =   4620
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   5190
   Icon            =   "FrmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4620
   ScaleWidth      =   5190
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPoke 
      Caption         =   "Poke"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   10
      Top             =   4080
      Width           =   1695
   End
   Begin VB.CommandButton cmdPeek 
      Caption         =   "Peek"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   9
      Top             =   3600
      Width           =   1695
   End
   Begin VB.Timer Timer1 
      Interval        =   20
      Left            =   960
      Top             =   2280
   End
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   375
      Left            =   3360
      TabIndex        =   8
      Top             =   3120
      Width           =   1695
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run"
      Height          =   375
      Left            =   3360
      TabIndex        =   7
      Top             =   2640
      Width           =   1695
   End
   Begin VB.CommandButton CmdStep 
      Caption         =   "Step"
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   2160
      Width           =   1695
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   2280
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtCode 
      Height          =   1695
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   5
      Text            =   "FrmMain.frx":0442
      ToolTipText     =   "Display of instructions being executed"
      Top             =   240
      Width           =   2415
   End
   Begin VB.Frame frmStatus 
      Caption         =   "STATUS"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1815
      Left            =   3360
      TabIndex        =   0
      Top             =   120
      Width           =   1695
      Begin VB.Label lblCycles 
         Caption         =   "lblCycles"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   1440
         Width           =   1455
      End
      Begin VB.Label LblV 
         Caption         =   "lblV"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   1080
         Width           =   1455
      End
      Begin VB.Label lblAccum 
         Caption         =   "lblAccum"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   720
         Width           =   1455
      End
      Begin VB.Label lblPC 
         Caption         =   "lblPC"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   360
         Width           =   1455
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open ROM..."
      End
      Begin VB.Menu mnuClose 
         Caption         =   "&Close ROM"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuRun 
      Caption         =   "&Run"
      Begin VB.Menu mnuStep 
         Caption         =   "&Single Step"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuContents 
         Caption         =   "&Contents..."
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "&About..."
      End
   End
End
Attribute VB_Name = "FrmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Initialize processor (just one for now)
Public MISC As New F4
Public RunIT As Boolean


Private Sub Update_status()
'Update status display of F4
  Dim Counter As Long
  Dim LastOne As Long
  lblAccum.Caption = "A: " + CStr(MISC.Accumulator)
  lblPC.Caption = "PC: " + CStr(MISC.PCounter)
  If (MISC.Overflow = False) Then LblV.Caption = "V: False" Else: LblV.Caption = "V: True"
  lblCycles.Caption = "Cycles: " + CStr(MISC.Cycles)
  txtCode.Text = " --> "
  Counter = MISC.PCounter
  If (MISC.HiMem - Counter) < 20 Then LastOne = MISC.HiMem Else: LastOne = Counter + 20
  Do While Counter < LastOne
    txtCode.Text = txtCode.Text + MISC.Disassemble(Counter) + Chr(13) + Chr(10)
    Counter = Counter + 2
  Loop
End Sub
  
Private Sub cmdReset_Click()
  MISC.Reset
  Call Update_status
End Sub

Private Sub cmdRun_KeyDown(KeyCode As Integer, Shift As Integer)
  cmdRun.Caption = "Release to stop"
  RunIT = True
End Sub

Private Sub cmdRun_KeyUp(KeyCode As Integer, Shift As Integer)
  cmdRun.Caption = "Run"
  RunIT = False
End Sub

Private Sub cmdRun_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  cmdRun.Caption = "Release to stop"
  RunIT = True
End Sub

Private Sub cmdRun_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  cmdRun.Caption = "Run"
  RunIT = False
End Sub

Private Sub CmdStep_Click()
  MISC.Step
  Call Update_status
End Sub

Private Sub Form_Click()
  Call Update_status
End Sub


Private Sub Form_Load()
  RunIT = False
  
  Call Load_chip
  Call Update_status
End Sub


Private Sub mnuExit_Click()
  Unload Me
End Sub

Private Sub mnuStep_Click()
  Call MISC.Step
  Call Update_status
End Sub

Private Sub Timer1_Timer()
  If RunIT = True Then
     MISC.Step
     Call Update_status
  End If
End Sub

Private Sub Load_chip()
Dim fn As String
Dim n As Integer
  CommonDialog1.Flags = cdlOFNHideReadOnly
  CommonDialog1.DialogTitle = "Open RAM file"
  CommonDialog1.InitDir = App.Path
  CommonDialog1.Filter = "All Files (*.*)|*.*|RAM Files" & _
  "(*.ram)|*.ram|"
  CommonDialog1.FilterIndex = 2
  CommonDialog1.ShowOpen

  fn = CommonDialog1.filename
  MISC.Load_Ram (fn)
End Sub
